/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20120215-64 [Mar  4 2012]
 * Copyright (c) 2000 - 2012 Intel Corporation
 * 
 * Disassembly of /tmp/DarwinDumper/ACPIDump/AML/SSDT.aml, Sun Oct 25 12:06:06 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000002F9 (761)
 *     Revision         0x01
 *     Checksum         0x8C
 *     OEM ID           "DELLTP"
 *     OEM Table ID     "TPM"
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20090903 (537463043)
 */

DefinitionBlock ("/tmp/DarwinDumper/ACPIDump/AML/SSDT.aml", "SSDT", 1, "DELLTP", "TPM", 0x00003000)
{
    External (PPRP, IntObj)
    External (LPPR, IntObj)
    External (PPRQ, IntObj)
    External (TPME)
    External (TCGP)
    External (MORD)

    Scope (\)
    {
        Device (\_SB.PCI0.LPCB.TPM)
        {
            Name (_HID, EisaId ("BCM0102"))
            Name (_CID, EisaId ("PNP0C31"))
            Name (_STR, Unicode ("TPM 1.2 Device"))
            Name (_CRS, ResourceTemplate ()
            {
                Memory32Fixed (ReadOnly,
                    0xFED40000,         // Address Base
                    0x00005000,         // Address Length
                    )
            })
            OperationRegion (SMIP, SystemIO, 0xB2, One)
            Field (SMIP, ByteAcc, NoLock, Preserve)
            {
                IOB2,   8
            }

            OperationRegion (TPMR, SystemMemory, 0xFED40000, 0x5000)
            Field (TPMR, AnyAcc, NoLock, Preserve)
            {
                ACC0,   8
            }

            Method (PTS, 1, Serialized)
            {
                If (LAnd (LLess (Arg0, 0x06), LGreater (Arg0, 0x03)))
                {
                    If (LNot (And (MORD, 0x10)))
                    {
                        Store (0x02, TCGP)
                        Store (0x5A, IOB2)
                    }
                }

                Return (Zero)
            }

            Method (_STA, 0, NotSerialized)
            {
                If (LEqual (TPME, Zero))
                {
                    Return (Zero)
                }

                If (LNotEqual (ACC0, 0xFF))
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (HINF, 3, Serialized)
            {
                Name (_T_0, Zero)
                Store (ToInteger (Arg1), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                         0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        If (LEqual (_STA (), Zero))
                        {
                            Return (Package (0x01)
                            {
                                Zero
                            })
                        }

                        Return (Package (0x02)
                        {
                            One, 
                            Package (0x02)
                            {
                                One, 
                                0x20
                            }
                        })
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Return (Buffer (Zero) {})
            }

            Name (TPM2, Package (0x02)
            {
                Zero, 
                Zero
            })
            Name (TPM3, Package (0x03)
            {
                Zero, 
                Zero, 
                Zero
            })
            Method (TPPI, 3, Serialized)
            {
                Name (_T_0, Zero)
                Store (ToInteger (Arg1), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                         0x3F
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Return ("1.0")
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x02))
                        {
                            Store (ToInteger (Arg2), PPRQ)
                            Store (0x02, TCGP)
                            Store (0x5B, IOB2)
                            Return (Zero)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x03))
                            {
                                Store (PPRQ, Index (TPM2, One))
                                Return (TPM2)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x04))
                                {
                                    Return (0x02)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x05))
                                    {
                                        Store (0x05, TCGP)
                                        Store (0x5B, IOB2)
                                        Store (LPPR, Index (TPM3, One))
                                        Store (PPRP, Index (TPM3, 0x02))
                                        Return (TPM3)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x06))
                                        {
                                            Return (Zero)
                                        }
                                        Else
                                        {
                                            BreakPoint
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                Return (One)
            }

            Method (SMBS, 3, Serialized)
            {
                Name (_T_0, Zero)
                Store (ToInteger (Arg1), _T_0)
                If (LEqual (_T_0, Zero))
                {
                    Return (Buffer (One)
                    {
                         0x01
                    })
                }
                Else
                {
                    If (LEqual (_T_0, One))
                    {
                        Store (ToInteger (Arg2), MORD)
                        Store (One, TCGP)
                        Store (0x5A, IOB2)
                        Return (Zero)
                    }
                    Else
                    {
                        BreakPoint
                    }
                }

                Return (One)
            }

            Method (_DSM, 4, Serialized)
            {
                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0xA5, 0x16, 0x8E, 0xCF, 0xE8, 0xC1, 0x25, 0x4E,
                            /* 0008 */   0xB7, 0x12, 0x4F, 0x54, 0xA9, 0x67, 0x02, 0xC8
                        }))
                {
                    Return (HINF (Arg1, Arg2, Arg3))
                }

                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0xA6, 0xFA, 0xDD, 0x3D, 0x1B, 0x36, 0xB4, 0x4E,
                            /* 0008 */   0xA4, 0x24, 0x8D, 0x10, 0x08, 0x9D, 0x16, 0x53
                        }))
                {
                    Return (TPPI (Arg1, Arg2, Arg3))
                }

                If (LEqual (Arg0, Buffer (0x10)
                        {
                            /* 0000 */   0xED, 0x54, 0x60, 0x37, 0x13, 0xCC, 0x75, 0x46,
                            /* 0008 */   0x90, 0x1C, 0x47, 0x56, 0xD7, 0xF2, 0xD4, 0x5D
                        }))
                {
                    Return (SMBS (Arg1, Arg2, Arg3))
                }

                Return (Buffer (One)
                {
                     0x00
                })
            }
        }
    }
}

